unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ImgList, ComCtrls, ToolWin,
  FlexBase, FlexUtils, MyCtrls, MyProps;

type
  TfmMain = class(TForm)
    ToolBar1: TToolBar;
    tbtSelect: TToolButton;
    tbtMyComplex: TToolButton;
    tbtZoom: TToolButton;
    tbtPan: TToolButton;
    imgTools: TImageList;
    fpView: TFlexPanel;
    ToolButton1: TToolButton;
    tbtEdit: TToolButton;
    tbtLoad: TToolButton;
    tbtSave: TToolButton;
    od_Main: TOpenDialog;
    sd_Main: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure tbtSelectClick(Sender: TObject);
    procedure tbtZoomClick(Sender: TObject);
    procedure tbtPanClick(Sender: TObject);
    procedure tbtMyComplexClick(Sender: TObject);
    procedure tbtEditClick(Sender: TObject);
    procedure fpViewNotify(Sender: TObject; Control: TFlexControl;
      Notify: TFlexNotify);
    procedure fpViewDblClick(Sender: TObject);
    procedure fpViewControlCreate(Sender: TObject; Control: TFlexControl);
    procedure tbtLoadClick(Sender: TObject);
    procedure tbtSaveClick(Sender: TObject);
  private
    { Private declarations }
    FDataValue: integer;
    procedure CheckTools;
  public
    { Public declarations }
  end;

var
  fmMain: TfmMain;

implementation

{$R *.DFM}

procedure TfmMain.FormCreate(Sender: TObject);
begin
 LoadFlexCursors;
 fpView.InDesign := true;
 FDataValue := 1;
 CheckTools;
end;

procedure TfmMain.tbtSelectClick(Sender: TObject);
begin
 fpView.ToolMode := ftmSelect;
 fpView.CreatingControlClass := Nil;
end;

procedure TfmMain.tbtZoomClick(Sender: TObject);
begin
 fpView.ToolMode := ftmZoom;
 fpView.CreatingControlClass := Nil;
end;

procedure TfmMain.tbtPanClick(Sender: TObject);
begin
 fpView.ToolMode := ftmPan;
 fpView.CreatingControlClass := Nil;
end;

procedure TfmMain.tbtMyComplexClick(Sender: TObject);
begin
 fpView.ToolMode := ftmSelect;
 fpView.CreatingControlClass := TMyComplexControl;
end;

procedure TfmMain.tbtEditClick(Sender: TObject);
var MyComplex: TMyComplexProp;
begin
 // Get flex property by name
 MyComplex := TMyComplexProp(fpView.Selected[0].Props['MyComplex']);
 if not Assigned(MyComplex) then exit;
 // Do property edit
 MyComplex.Edit;
end;

procedure TfmMain.fpViewNotify(Sender: TObject; Control: TFlexControl;
  Notify: TFlexNotify);
begin
 if Notify = fnSelect then CheckTools;
end;

procedure TfmMain.CheckTools;
begin
 // Edit button is active when single control selected and it contain
 // flex-property with "MyComplex" name
 tbtEdit.Enabled := (fpView.SelectedCount = 1) and
   Assigned(fpView.Selected[0].Props['MyComplex']);
end;

procedure TfmMain.fpViewDblClick(Sender: TObject);
begin
 if tbtEdit.Enabled then tbtEdit.Click;
end;

procedure TfmMain.fpViewControlCreate(Sender: TObject; Control: TFlexControl);
begin
 if (Control is TMyComplexControl) then begin
  TMyComplexControl(Control).MyProp.Value := FDataValue;
  inc(FDataValue);
 end;
end;

procedure TfmMain.tbtLoadClick(Sender: TObject);
begin
 if not od_Main.Execute then exit;
 Screen.Cursor := crHourGlass;
 try
  fpView.LoadFromFile(od_Main.FileName);
 finally
  Screen.Cursor := crDefault;
 end;
end;

procedure TfmMain.tbtSaveClick(Sender: TObject);
begin
 if not sd_Main.Execute then exit;
 Screen.Cursor := crHourGlass;
 try
  fpView.SaveToFile(sd_Main.FileName);
 finally
  Screen.Cursor := crDefault;
 end;
end;

end.
