unit MyComplexFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Spin, StdCtrls, Buttons, FlexProps, MyProps;

type
  TMyComplexPropForm = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    edCaption: TEdit;
    Label1: TLabel;
    sedValue: TSpinEdit;
    Label2: TLabel;
    mmData: TMemo;
    Label3: TLabel;
    btFont: TButton;
    fd_Main: TFontDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure btFontClick(Sender: TObject);
  private
    { Private declarations }
    FProp: TMyComplexProp;
  public
    { Public declarations }
  end;

var
  MyComplexPropForm: TMyComplexPropForm;

implementation

{$R *.DFM}

procedure TMyComplexPropForm.FormCreate(Sender: TObject);
begin
 // In this method Tag property still not defined and
 // we can't get flex-property data
 edCaption.Text := '';
 sedValue.Value := 0;
 mmData.Text := '';
end;

procedure TMyComplexPropForm.FormShow(Sender: TObject);
var AFont: TFont;
begin
 FProp := TMyComplexProp(Tag);
 if not Assigned(FProp) then exit;
 // Setup form components by flex-property data
 with FProp do begin
  edCaption.Text := Caption;
  sedValue.Value := Value;
  mmData.Text := Data.Strings.Text;
  AFont := TFont.Create;
  try
   Font.GetFont(AFont);
   fd_Main.Font.Assign(AFont);
  finally
   AFont.Free;
  end;
 end;
end;

procedure TMyComplexPropForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 if ModalResult = mrOk then begin
  // Save edited values in flex-property
  if Assigned(FProp) then
  with FProp do begin
   Caption := edCaption.Text;
   Value := sedValue.Value;
   Data.Strings.Text := mmData.Text;
   Font.SetFont(fd_Main.Font);
  end;
  ModalResult := mrOk;
 end;
end;

procedure TMyComplexPropForm.btFontClick(Sender: TObject);
begin
 fd_Main.Execute;
end;

initialization
  RegisterDefaultPropEditForm(TMyComplexProp, TMyComplexPropForm);

end.
