unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FlexBase, FlexGif, FlexProps, FlexUtils, Buttons, ExtCtrls;

type
  TfmMain = class(TForm)
    fpView: TFlexPanel;
    Panel1: TPanel;
    sbtAnimate: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure sbtAnimateClick(Sender: TObject);
  private
    { Private declarations }
    FLam: TFlexGifPicture;
    FDancer: TFlexGifPicture;
    function CreateGif(const Filename: string): TFlexGifPicture;
  public
    { Public declarations }
  end;

var
  fmMain: TfmMain;

implementation

{$R *.DFM}

procedure TfmMain.FormCreate(Sender: TObject);
begin
 // Load background
 with TFlexScheme(fpView.ActiveScheme).BrushProp do begin
  InitBitmap;
  Bitmap.LoadFromFile(ExtractFilePath(ParamStr(0)) + 'bk2.bmp');
  Method := bmBitmap;
 end;
 fpView.SchemeBkStretch := true;
 // Load gifs
 FLam := CreateGif('lam.gif');
 FLam.Transparency := 50; // Alpha blend 50%
 FDancer := CreateGif('dancer.gif');
 FDancer.Left := (fpView.DocWidth - FDancer.Width) div 2;
 FDancer.Top := (fpView.DocHeight - FDancer.Height) div 2;
end;

function TfmMain.CreateGif(const Filename: string): TFlexGifPicture;
begin
 Result := TFlexGifPicture.Create(fpView, fpView.ActiveScheme,
   fpView.ActiveLayer);
 Result.PictureProp.LoadFromFile(ExtractFilePath(ParamStr(0)) + Filename);
 Result.AutoSizeProp.Value := true;
end;

procedure TfmMain.sbtAnimateClick(Sender: TObject);
begin
 FLam.AnimateProp.Value := sbtAnimate.Down;
 FDancer.AnimateProp.Value := sbtAnimate.Down;
end;

end.
