//---------------------------------------------------------------------------

#ifndef FlexMultiPicsH
#define FlexMultiPicsH

#include <Graphics.hpp>
#include <Classes.hpp>
#include <FlexBase.hpp>
#include <FlexUtils.hpp>
#include <FlexControls.hpp>

class TFlexMultiPicControl : public TFlexPicture
{
  private:
    typedef TFlexPicture inherited;
  private:
    TIntProp *FPictureIndexProp;
    TDataProp *FPictureListProp;
  protected:
    TList *FPictureList;
    virtual void __fastcall ControlCreate(void);
    virtual void __fastcall ControlDestroy(void);
    virtual void __fastcall CreateProperties(void);
    virtual void __fastcall PropChanged(System::TObject* Sender,
      Flexprops::TCustomProp* Prop);
    virtual void __fastcall PropStored(System::TObject* Sender,
      Flexprops::TCustomProp* Prop, bool &IsStored,
      const AnsiString PropName = "");
    void __fastcall PictureListItemChange(System::TObject* Sender);
    TPicture * __fastcall GetImage(int Index);
    int __fastcall GetImageCount(void);
  public:
    __fastcall virtual TFlexMultiPicControl(TFlexPanel* AOwner,
      TFlexControl* AParent, TFlexLayer* ALayer):
        TFlexPicture(AOwner, AParent, ALayer) {};
    void __fastcall ClearPictureList(void);
    int __fastcall AddImage(TPicture *ASource = NULL);
    void __fastcall DeleteImage(int Index);
    void __fastcall GetPictureListData(System::TObject* Sender, Variant &Value);
    void __fastcall SetPictureListData(System::TObject* Sender, Variant &Value);
    __property TIntProp *PictureIndexProp = {read=FPictureIndexProp};
    __property TDataProp *PictureListProp = {read=FPictureListProp};
    __property int ImageCount = {read=GetImageCount};
    __property TPicture *Images[int Index] = {read=GetImage};
};

void __fastcall VariantToPictureList(TList *PicList, Variant &Value);
void __fastcall PictureListToVariant(TList *PicList, Variant &Value);

void RegisterFlexMultiPicControl(void);

#pragma startup RegisterFlexMultiPicControl

//---------------------------------------------------------------------------
#endif
